"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Command = void 0;
const commander_1 = __importDefault(require("commander"));
class Command {
    constructor(name, description, version) {
        this.program = new commander_1.default.Command()
            .name(name)
            .description(description)
            .version(version);
    }
    createCommand(command, action = () => { }) {
        const subCommand = new commander_1.default.Command()
            .command(command.name)
            .description(command.description);
        this._addOptions(this._addArguments(subCommand, command.arguments, command.arguments.length), command.options, command.options.length).action(action);
        this.program.addCommand(subCommand);
    }
    _addArguments(command, args, len) {
        if (len == 0)
            return command;
        const currentArg = args[args.length - len];
        return this._addArguments(command.argument(currentArg.name, currentArg.description, currentArg.defaultValue), args, len - 1);
    }
    _addOptions(command, opts, len) {
        if (len == 0)
            return command;
        const currentOpt = opts[opts.length - len];
        return this._addOptions(command.option(currentOpt.flags, currentOpt.description, currentOpt.defaultValue), opts, len - 1);
    }
}
exports.Command = Command;
