"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("./command");
const utils_1 = require("./lib/utils");
const executor_1 = require("./executor");
const commandList_1 = __importDefault(require("./lib/commandList"));
const types_1 = require("./lib/types");
exports.default = async (argv) => {
    const runner = await executor_1.CommandExecutor.setup();
    const command = new command_1.Command("imaluum", "A tool to access i-Ma'luum directly from your command line.", require("../package.json").version);
    // This is so that `Runner` class can have access to the `Command` error function
    // throwing a normal error would not allows `Command` to handle it.
    // Somewhat a janky solution, but it should be okay for now.
    runner.setErrorCallback((message) => command.program.error(message));
    for (const item in commandList_1.default) {
        command.createCommand(commandList_1.default[item], async (...args) => {
            const enumKey = (0, utils_1.capitalize)(item);
            runner.execute(types_1.CommandEnum[enumKey], ...args);
        });
    }
    await command.program.parseAsync(argv);
};
