"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseHTMLTableJson = exports.readFromFileSync = exports.writeToFileSync = exports.styleText = exports.capitalize = void 0;
const node_fs_1 = __importDefault(require("node:fs"));
const types_1 = require("../types");
const HTMLTableToJson = require('html-table-to-json');
function capitalize(str) {
    const newStr = str.toLowerCase();
    return newStr.replace(/^\w/, newStr.charAt(0).toUpperCase());
}
exports.capitalize = capitalize;
function styleText(text, ...styles) {
    const style = "".concat(...styles);
    return `${style}${text}\x1b[0m`;
}
exports.styleText = styleText;
const writeToFileSync = (path, data) => {
    const file = node_fs_1.default.openSync(path, "w+");
    node_fs_1.default.writeFileSync(file, data);
    node_fs_1.default.close(file);
};
exports.writeToFileSync = writeToFileSync;
const readFromFileSync = (path) => {
    const file = node_fs_1.default.openSync(path, "as+");
    const data = node_fs_1.default.readFileSync(file, { encoding: "utf8" });
    node_fs_1.default.close(file);
    return data;
};
exports.readFromFileSync = readFromFileSync;
const parseHTMLTableJson = (tableHTMLString) => {
    const jsonTable = HTMLTableToJson.parse(tableHTMLString).results[0];
    const tableElem = [];
    // fetch keys
    tableElem.push(Object.entries(jsonTable[0]).map((entry) => styleText(entry[0], types_1.AnsiColourEnum.GREEN, types_1.AnsiTextStyleEnum.BOLD)));
    for (let i = 0; i < jsonTable.length; i++) {
        tableElem.push(Object.entries(jsonTable[i]).map((entry) => entry[1]));
    }
    return tableElem;
};
exports.parseHTMLTableJson = parseHTMLTableJson;
